diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 88be83130..446c67f22 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -3,12 +3,15 @@ package net.minecraft.client.render.texture.stitcher;
 
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.HardIllegalArgumentException;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
+import java.awt.image.BufferedImage;
 import java.io.File;
 import java.io.FileWriter;
 import java.io.IOException;
@@ -33,20 +36,44 @@ import java.util.stream.Stream;
 
 public class TextureRegistry {
     private static final Logger LOGGER = LogUtils.getLogger();
-    public static HashMap<String, AtlasStitcher> stitcherMap = new HashMap<>();
-    public static HashMap<AtlasStitcher, String> stitcherMapReverse = new HashMap<>();
-    @SuppressWarnings("unused")
-    public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", false, true, "/assets/minecraft/textures/block/texture_missing.png"));
-    @SuppressWarnings("unused")
-    public static AtlasStitcher itemAtlas =  register("item", new AtlasStitcher("textures/item", false, true, "/assets/minecraft/textures/item/texture_missing.png"));
+    public static List<AtlasStitcher> atlases = new ObjectArrayList<>();
+    public static Map<String, AtlasStitcher> stitcherMap = new Object2ObjectOpenHashMap<>();
+    public static final BufferedImage missingIconImage = new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB);
+    static {
+        for (int x = 0; x < 16; x++) {
+            for (int y = 0; y < 16; y++) {
+                if ((((x/8) + (y/8)) & 0b1) == 0) {
+                    missingIconImage.setRGB(x, y, 0xFFFF00FF);
+                } else {
+                    missingIconImage.setRGB(x, y, 0xFF000000);
+                }
+            }
+        }
+    }
+
     @SuppressWarnings("unused")
-    public static AtlasStitcher particleAtlas = register("particle", new AtlasStitcher("textures/particle", false, true, null));
+    public static AtlasStitcher worldAtlas = register(
+        new AtlasStitcher(false, true, missingIconImage)
+            .addDirectory("block", "textures/block")
+            .addDirectory("item", "textures/item")
+            .addDirectory("particle", "textures/particle")
+    );
+
     @SuppressWarnings("unused")
-    public static AtlasStitcher artAtlas = register("art", new AtlasStitcher("textures/art", false, true, null));
+    public static AtlasStitcher artAtlas = register(
+        new AtlasStitcher(false, true, null)
+            .addDirectory("art", "textures/art")
+    );
     @SuppressWarnings("unused")
-    public static AtlasStitcher guiSpriteAtlas = register("gui", new AtlasStitcher("textures/gui/sprites", true, false, null));
+    public static AtlasStitcher guiSpriteAtlas = register(
+        new AtlasStitcher(true, false, null)
+            .addDirectory("gui", "textures/gui/sprites")
+    );
     @SuppressWarnings("unused")
-    public static AtlasStitcher signAtlas = register("sign", new AtlasStitcher("textures/gui/sign", false, false, null));
+    public static AtlasStitcher signAtlas = register(
+        new AtlasStitcher(false, false, null)
+            .addDirectory("sign", "textures/gui/sign")
+    );
 
     public static @NotNull IconCoordinate getTexture(@NotNull String key){
         try {
@@ -57,10 +84,11 @@ public class TextureRegistry {
     }
     public static @NotNull IconCoordinate getTexture(@NotNull NamespaceID id){
         final int slashIndex = id.value().indexOf("/");
-        final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
-        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
+        String atlasId = id.value().substring(0, slashIndex);
+        final AtlasStitcher atlas = stitcherMap.get(atlasId);
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + atlasId + "'! From ID: " + id);
 
-        return atlas.getTexture(id, NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
+        return atlas.getTexture(id);
     }
     public static boolean hasTexture(@NotNull String key) {
         try {
@@ -71,20 +99,23 @@ public class TextureRegistry {
     }
     public static boolean hasTexture(@NotNull NamespaceID id){
         final int slashIndex = id.value().indexOf("/");
-        final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
-        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
+        String atlasId = id.value().substring(0, slashIndex);
+        final AtlasStitcher atlas = stitcherMap.get(atlasId);
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + atlasId + "'!");
 
         return atlas.textureMap.containsKey(NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
     }
-    public static AtlasStitcher register(String id, AtlasStitcher atlas){
-        stitcherMap.put(id, atlas);
-        stitcherMapReverse.put(atlas, id);
+    public static @NotNull AtlasStitcher register(@NotNull AtlasStitcher atlas){
+        for (String id : atlas.idDirMap.keySet()) {
+            stitcherMap.put(id, atlas);
+        }
+        atlases.add(atlas);
         return atlas;
     }
     static {
         // Initialize all textures in case they aren't normally done before the textures are first refreshed
         try {
-            for (AtlasStitcher stitcher : stitcherMap.values()){
+            for (AtlasStitcher stitcher : atlases){
                 initializeAllFiles("minecraft", stitcher, stitcher != artAtlas);
             }
         } catch (Exception e) {
@@ -92,18 +123,8 @@ public class TextureRegistry {
         }
     }
 
-    public static void initializeAllFiles(String namespace, AtlasStitcher atlas, boolean subDirectories) throws URISyntaxException, IOException, NullPointerException {
-        String path = String.format("%s/%s/%s", AtlasStitcher.rootAssetPath, namespace, atlas.directoryPath);
-
-        String[] files = getFilesAndSubFiles(path, subDirectories);
-
-//        System.out.println("Printing " + path);
-        for (String s : files) {
-//            System.out.println(s);
-
-            NamespaceID id = NamespaceID.fromPool(namespace, s.replace(".png", "").replace("//", "/"));
-            atlas.getTexture(NamespaceID.fromPool(id.namespace(), stitcherMapReverse.get(atlas) + "/" + id.value()), id);
-        }
+    public static void initializeAllFiles(@NotNull String namespace, @NotNull AtlasStitcher atlas, boolean subDirectories) throws URISyntaxException, IOException, NullPointerException {
+        atlas.initializeAll(namespace, subDirectories);
     }
 
     public static String[] getFilesAndSubFiles(String directory, boolean searchSubDirectories) throws IOException, URISyntaxException {
@@ -176,7 +197,7 @@ public class TextureRegistry {
                 try (final FileWriter writer = new FileWriter(tileFile)) {
                     writer.append("# Auto generated tiles mapping for atlas '").append(stitcherEntry.getKey()).append("'\n");
                     writer.append("# generated for version '").append(Global.VERSION).append("' at '").append(dateFormat.format(new Date())).append("'\n");
-                    writer.append("size=").append(Integer.toString(stitcher.atlas.getWidth())).append("x").append(Integer.toString(stitcher.atlas.getHeight())).append("\n");
+                    writer.append("size=").append(Integer.toString(stitcher.getAtlasWidth())).append("x").append(Integer.toString(stitcher.getAtlasHeight())).append("\n");
                     for (final Map.Entry<NamespaceID, IconCoordinate> entry : stitcher.textureMap.entrySet()) {
                         final IconCoordinate coordinate = entry.getValue();
                         writer.append(Integer.toString(coordinate.iconX)).append(",").append(Integer.toString(coordinate.iconY));
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 23aed9361..1e1312569 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -4,7 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
@@ -108,7 +108,7 @@ public class TexturePackList
 		BlockModelDispatcher.getInstance().reload();
 		ItemModelDispatcher.getInstance().reload();
 		EntityGeometryMojangData.Cache.reload(this);
-		EntityRenderDispatcher.instance.reload();
+		EntityRendererDispatcher.instance.reload();
 		TileEntityRenderDispatcher.instance.reload();
 		KeyboardLayout.defaultLayout = new KeyboardLayout();
 		TooltipElement.reloadStyles(this);
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index 30c7370a0..a4dbff3c8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -4,7 +4,7 @@ import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.util.collection.NamespaceID;
@@ -29,7 +29,7 @@ public abstract class TileEntityRenderer<T extends TileEntity>
 
     public void tick() {}
 
-    public abstract void doRender(Tessellator tessellator, T tileEntity, double x, double y, double z,
+    public abstract void doRender(TessellatorGeneral tessellator, T tileEntity, double x, double y, double z,
                                   float partialTick);
 
     protected void bindTexture(final String texturePath)
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 8f049ddda..79a43b13a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -2,7 +2,10 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FlagRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
 
@@ -10,13 +13,10 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.wind.WindProvider;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
 
-public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
-{
+public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag> {
 
     private final @NotNull FlagRenderer flagRenderer = new FlagRenderer(Minecraft.getMinecraft().textureManager);
     public final Minecraft mc = Minecraft.getMinecraft();
@@ -26,7 +26,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
     }
 
     @Override
-    public void doRender(final @NotNull Tessellator tessellator, @NotNull final TileEntityFlag tileEntity, final double x, final double y, final double z, final float partialTick) {
+    public void doRender(final @NotNull TessellatorGeneral tessellator, @NotNull final TileEntityFlag tileEntity, final double x, final double y, final double z, final float partialTick) {
         final World theWorld = Minecraft.getMinecraft().currentWorld;
         final int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
         final boolean shortPole = blockUnder == Blocks.FLAG.id();
@@ -35,57 +35,56 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
 
         final float windDirection = theWind.getWindDirection(this.mc.currentWorld, 0.0f, 500.0f, 0.0f) * 360f;
         final float windIntensity = theWind.getWindIntensity(this.mc.currentWorld, 0.0f, 500.0f, 0.0f);
-        
+
         doRender(tessellator, tileEntity, x, y, z, partialTick, shortPole, windDirection, windIntensity);
     }
 
     private long lastTick = 0;
-    public void doRender(final @NotNull Tessellator tessellator, final @NotNull TileEntityFlag tileEntityFlag, final double x, final double y, final double z, final float partialTick, final boolean shortPole, final float windDirection, final float windIntensity)
-    {
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+
+    public void doRender(final @NotNull TessellatorGeneral tessellator, final @NotNull TileEntityFlag tileEntityFlag, final double x, final double y, final double z, final float partialTick, final boolean shortPole, final float windDirection, final float windIntensity) {
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final World theWorld = this.mc.currentWorld;
         if (theWorld.getWorldTime() != this.lastTick) {
             this.lastTick = theWorld.getWorldTime();
             this.flagRenderer.tick();
         }
-        
+
         final float swayInterpolated = tileEntityFlag.sway + partialTick;
-        
+
         float sway = (float) ((swayInterpolated / 1.5) % (2 * Math.PI));
         sway = (float) (Math.sin(sway) * windIntensity * 2.0f);
-        
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float) x + 0.5F, (float) y, (float) z + 0.5F);
-        GL11.glScalef(1/16F, 1/16F, -1/16F);
+
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x + 0.5F, (float) y, (float) z + 0.5F);
+        GLRenderer.modelM4f().scale(1 / 16F, 1 / 16F, -1 / 16F);
         bindTexture("/assets/minecraft/textures/entity/flag.png");
         final StaticEntityModel flagModel = shortPole ? getModel("pole.short") : getModel("pole.long");
 
         if (shortPole) {
-            GL11.glTranslatef(0, 18, 0);
+            GLRenderer.modelM4f().translate(0, 18, 0);
         }
 
         flagModel.getTransform("flag").rotY = (windDirection + sway) * MathHelper.DEG_TO_RAD;
-        flagModel.render(tessellator);
+        flagModel.render();
 
         flagModel.translateToBone("flag");
         bindTexture("/assets/minecraft/textures/entity/flag_ui.png");
         if (tileEntityFlag.getFlipped()) {
-            getModel("cloth.mirror").render(tessellator);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+            getModel("cloth.mirror").render();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.ONE_MINUS_SRC_COLOR, BlendFactor.SRC_COLOR);
             this.renderDispatcher.textureManager.bindTexture(this.flagRenderer.getTexture(tileEntityFlag));
-            getModel("cloth.mirror").render(tessellator);
+            getModel("cloth.mirror").render();
         } else {
-            getModel("cloth").render(tessellator);
-            GL11.glEnable(GL11.GL_BLEND);
-            GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
+            getModel("cloth").render();
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.ONE_MINUS_SRC_COLOR, BlendFactor.SRC_COLOR);
             this.renderDispatcher.textureManager.bindTexture(this.flagRenderer.getTexture(tileEntityFlag));
-            getModel("cloth").render(tessellator);
+            getModel("cloth").render();
         }
-        GL11.glDisable(GL11.GL_BLEND);
+        GLRenderer.disableState(State.BLEND);
 
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.popFrame();
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index 739e5400a..90869313a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -1,17 +1,13 @@
 package net.minecraft.client.render.tileentity;
 
-import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
-import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.world.World;
-import net.minecraft.core.world.WorldSource;
 import org.lwjgl.opengl.GL11;
 
 import static org.lwjgl.opengl.GL11.GL_BLEND;
@@ -21,28 +17,23 @@ import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
 public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFlowerJar> {
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
-        GL11.glPushMatrix();
+    public void doRender(TessellatorGeneral tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
+        GLRenderer.pushFrame();
         Block<?> block = Blocks.getBlock(tileEntity.flowerInPot);
-        if(block != null){
-            GL11.glTranslatef((float)x, (float)y, (float)z);
-            TextureRegistry.blockAtlas.bind();
+        if (block != null) {
+            GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
+            TextureRegistry.worldAtlas.bind();
             float scaleValue = 0.75F;
-            GL11.glScalef(scaleValue, scaleValue, scaleValue);
-            GL11.glTranslatef(0.66F, 0.75F, 0.66F);
+            GLRenderer.modelM4f().scale(scaleValue, scaleValue, scaleValue);
+            GLRenderer.modelM4f().translate(0.66F, 0.75F, 0.66F);
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
             Lighting.disable();
-            BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, getBlockBrightness(tileEntity.worldObj, tileEntity.x, tileEntity.y, tileEntity.z), 1f, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, Minecraft.getMinecraft().isFullbrightEnabled() ? 15 : 0));
+            BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
             Lighting.enableLight();
             GL11.glDisable(GL_BLEND);
         }
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
 
-    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z)
-    {
-        if (Minecraft.getMinecraft().fullbright || LightmapHelper.isLightmapEnabled()) return 1.0f;
-        return blockAccess.getBrightness(x, y, z, 0);
-    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
index 3f95b2e7f..6c5206ab9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.entity.MobRendererButterfly;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.entity.TileEntityJarButterfly;
 import net.minecraft.core.util.helper.MathHelper;
 
 public class TileEntityRendererJarButterfly extends TileEntityRenderer<TileEntityJarButterfly>{
     @Override
-    public void doRender(Tessellator tessellator, TileEntityJarButterfly tileEntity, double x, double y, double z, float partialTick) {
+    public void doRender(TessellatorGeneral tessellator, TileEntityJarButterfly tileEntity, double x, double y, double z, float partialTick) {
         MobRendererButterfly.drawButterfly(tessellator, tileEntity.ticksRan, 0.70f, 0, x + 0.5, y - 0.125 + MathHelper.sin((tileEntity.ticksRan + partialTick)/20) * (0.0625), z + 0.5, partialTick, renderDispatcher.textureManager, "/assets/minecraft/textures/entity/butterfly/" + tileEntity.color.name + "/0_0.png");
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
index 29862758c..209b75455 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
@@ -1,31 +1,30 @@
 package net.minecraft.client.render.tileentity;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityMeshGold;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.util.helper.MathHelper;
-import org.lwjgl.opengl.GL12;
-import org.useless.dragonfly.DisplayPos;
+import net.minecraft.core.world.pos.TilePos;
 
 public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMeshGold> {
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float renderPartialTicks) {
-        if(tileEntity.filterItem == null) return;
-        GL11.glPushMatrix();
+    public void doRender(TessellatorGeneral tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float renderPartialTicks) {
+        if (tileEntity.filterItem == null) return;
+        GLRenderer.pushFrame();
 
         final float bobbingOffset = MathHelper.sin((tileEntity.ticksRan + renderPartialTicks) / 10F) * 0.1F + 0.1F;
         final float yaw = (float) Math.toDegrees(((tileEntity.ticksRan + renderPartialTicks) / 20F));
 
-        GL11.glTranslatef((float) x + 0.5f, (float) y + bobbingOffset + 0.25f, (float) z + 0.5f);
+        GLRenderer.modelM4f().translate((float) x + 0.5f, (float) y + bobbingOffset + 0.25f, (float) z + 0.5f);
 
-        float lightLevel = Minecraft.getMinecraft().currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
-        if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
-        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem, Minecraft.getMinecraft().gameSettings.items3D.value, 1, tileEntity.ticksRan, yaw, lightLevel, 1f, renderPartialTicks);
-        GL11.glPopMatrix();
+
+        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem,
+            Minecraft.getMinecraft().gameSettings.items3D.value, 1, tileEntity.ticksRan, yaw,
+            Minecraft.getMinecraft().currentWorld.getLightmapCoord(new TilePos(tileEntity.x, tileEntity.y, tileEntity.z), 0), renderPartialTicks);
+        GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index c3b23b9bf..5b20c4cc1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -3,57 +3,53 @@ package net.minecraft.client.render.tileentity;
 import java.util.HashMap;
 import java.util.Map;
 
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.entity.TileEntityMobSpawner;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.world.World;
-import org.lwjgl.opengl.GL11;
+import org.joml.Math;
 
-public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityMobSpawner>
-{
+public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityMobSpawner> {
 
-    public TileEntityRendererMobSpawner()
-    {
-        entityHashMap = new HashMap<>();
+    private final Map<String, Entity> entityHashMap;
+
+    public TileEntityRendererMobSpawner() {
+        this.entityHashMap = new HashMap<>();
     }
-    public void onWorldChanged(World world)
-    {
-        entityHashMap.clear();
+
+    public void onWorldChanged(World world) {
+        this.entityHashMap.clear();
     }
 
     @Override
-	public void doRender(Tessellator tessellator, TileEntityMobSpawner mobSpawner, double x, double y, double z,
-                         float partialTick)
-    {
-        GL11.glPushMatrix();
-        GL11.glTranslatef((float)x + 0.5F, (float)y, (float)z + 0.5F);
-        Entity entity = entityHashMap.get(mobSpawner.getMobId());
-        if(entity == null)
-        {
+    public void doRender(TessellatorGeneral tessellator, TileEntityMobSpawner mobSpawner, double x, double y, double z,
+                         float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate((float) x + 0.5F, (float) y, (float) z + 0.5F);
+        Entity entity = this.entityHashMap.get(mobSpawner.getMobId());
+        if (entity == null) {
             entity = EntityDispatcher.getInstance().createEntityInWorld(mobSpawner.getMobId(), WorldClient.EMPTY_WORLD);
-            entityHashMap.put(mobSpawner.getMobId(), entity);
+            this.entityHashMap.put(mobSpawner.getMobId(), entity);
         }
-        if(entity != null)
-        {
+        if (entity != null) {
             entity.setWorld(mobSpawner.worldObj);
             float f1 = 0.4375F;
-            GL11.glTranslatef(0.0F, 0.4F, 0.0F);
-            GL11.glRotatef((float)(mobSpawner.yaw2 + (mobSpawner.yaw - mobSpawner.yaw2) * (double)partialTick) * 10F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-30F, 1.0F, 0.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -0.4F, 0.0F);
-            GL11.glScalef(f1, f1, f1);
+            GLRenderer.modelM4f().translate(0.0F, 0.4F, 0.0F);
+            GLRenderer.modelM4f().rotateY((float) Math.toRadians((mobSpawner.yaw2 + (mobSpawner.yaw - mobSpawner.yaw2) * (double) partialTick) * 10F));
+            GLRenderer.modelM4f().rotateX(Math.toRadians(-30F));
+            GLRenderer.modelM4f().translate(0.0F, -0.4F, 0.0F);
+            GLRenderer.modelM4f().scale(f1, f1, f1);
 //            System.out.printf("X: %f, Y: %f, Z: %f\n", x, y, z);
             entity.moveTo(mobSpawner.x, mobSpawner.y, mobSpawner.z, 0.0F, 0.0F);
             EntityRenderer.renderShadows = false;
-            EntityRenderDispatcher.instance.renderEntityWithPosYaw(tessellator, entity, 0.0D, 0.0D, 0.0D, 0.0F, partialTick);
+            EntityRendererDispatcher.instance.renderEntityWithPosYaw(tessellator, entity, 0.0D, 0.0D, 0.0D, 0.0F, partialTick);
             EntityRenderer.renderShadows = true;
         }
-        GL11.glPopMatrix();
+        GLRenderer.popFrame();
     }
-
-    private final Map<String, Entity> entityHashMap;
 }
